# CS430 F2023 Materials

Putting this stuff here because (a) I despise Moodle, and (b) I want to keep my own copies, and (c) it maybe encourages people to use git.

## [In the Beginning was the Command Line]( https://smorgasborg.artlung.com/C_R_Y_P_T_O_N_O_M_I_C_O_N.shtml )

We will cover two topics:

* the [git distributed source control system]( https://git-scm.com/ ), and
* the "Unix Tools" style of shell programming with small tools and pipes.

Familiarity with these is critical for effective use of both big remote platforms like cloud computing or clusters, and small-footprint devices like routers and set-top boxes.

#### Preparation

Please make sure you have git installed: `sudo apt install git` would do it for me. If you have a Linux machine or a Mac, you should know how to start a shell window. If you have a Windows machine, please install [WSL]( https://learn.microsoft.com/en-us/windows/wsl/ ).

#### Get Git Good (assignment & materials)

Here are some resources for learning git, in various forms: interactive tutorials, gamified tutorials, and even serious courses.

* https://ohmygit.org/ (game)
* https://profy.dev/project/github-minesweeper (game, github focus)
* https://learngitbranching.js.org/ (interactive tutorial)
* https://githowto.com/ (lightweight guided tour)
* https://gitimmersion.com/ (guided tour; sets up git and ruby for web dev; 52 labs!)
* https://www.codecademy.com/learn/learn-git (15-hour course, focused on github)

Play with one or more of the above until you feel comfortable using branches, merging, making tags, rewriting history, fetch/push to remote repos, and basically know your way around git enough to use it effectively to support various workflows.

When you're done, use your account on https://gitlab.cs.nuim.ie (you might need to make one) to fork https://gitlab.cs.nuim.ie/barak/cs430-git-is-good and make a pull request adding yourself to the list of people who know git.
For redundancy (in case I mess up and drop your pull request) please submit (on Moodle) a two-word assignment: the URL and commit ID of the git repo on the CS gitlab instance above and specific commit you've issued the pull request for. For me, it would be:

https://gitlab.cs.nuim.ie/barak/cs430-git-is-good 855af35f60e47234a1ecb9b2812387fbae2fbf8c

(This is not necessary if you already appear below.)

## Shell Scripting (mostly pipe: `foo|bar`) materials

* [Unix Philosophy in a Nutshell]( https://subscription.packtpub.com/book/programming/9781788998475/1/ch01lvl1sec04/the-unix-philosophy-in-a-nutshell )
* [History of Pipes Concept]( https://softpanorama.org/Scripting/Piporama/history.shtml ) “Pipes are notation for specifying coroutines in such a way that  any regular program that accepts input and produces based on it output  can act as a coroutine under the supervision of the OS, using so called I/O redirection.” In other words, “pipes allow regular programs that accept input and produce output to act as coroutines under OS supervision.”
* Nice [Shell Scripting Tutorial]( https://www.shellscript.sh/ )
* [bash(1)]( https://www.man7.org/linux/man-pages/man1/bash.1.html )

# CS430 F2023 Silly Repo

Make a pull request adding your name to this file.

## People in CS430 F2023 Who Know Git

* Barak A. Pearlmutter
* Eoghan Daly
* Daniil Kazakov
* Kevin Xia
* Wiktoria Buchacz
* Mantvydas Navickas
* Rory O'Hare
* Harry Keogh
* Carlos Milkovic
* Conor M. O'Leary
* Boris Stavisky - 20729171
* Boluwatife Nick Oguntuase
* Thomas Kilduff
* Louise McGuirk
* Martynas Jascemskas
* Cheemay Song
* Danielius Grebliauskas
* Andrew Walsh
* Ismael Plangca
* Maksymilian Glowacki
* Lauren Kelly
* Matthew Kenny
* Juk Scey Lee
* Mark Lynch
* Olatomiwa Abodunrin Omotoso
* Adam Corley
* Josh Mc Donnell
* Michael O'Neill
* Mario Jonathan Valeanu
* Maksim Orlov
* Anantha Vishnu R
* Stilian Kolev
* Bartosz Kowal
* Dáire Casey
